#include <iostream>

/* run this program using the console pauser or add your own getch, system("pause") or input loop */
class Node {
public:
	double	data;		// data
	Node*	next;		// pointer
};

class List {
public:
	List(void) { head = NULL; }	// constructor
	~List(void);				// destructor

	bool IsEmpty() { return head == NULL; } //bo kontrol
	Node* InsertNode(int index, double x);	//node ekle
	int FindNode(double x);	 //node bul
	int DeleteNode(double x); //node sil
	void DisplayList(void); //liste grntle
private:
	Node* head; //ba ksm
};

Node* List::InsertNode(int index, double x) {
	
	if (index < 0) return NULL;	
	
	int currIndex	=	1;
	Node* currNode	=	head;
	while (currNode && index > currIndex) {
		currNode	=	currNode->next;
		currIndex++;
	}
	if (index > 0 && currNode == NULL) return NULL;
	
	Node* newNode	=	new	Node;
	newNode->data	=	x;	
	if (index == 0) {
		newNode->next	=	head;
		head		=	newNode;
	}
	else{
		newNode->next	=	currNode->next;
		currNode->next	=	newNode;
	}
	return newNode;
}


int List::FindNode(double x) {
	Node* currNode	=	head;
	int currIndex	=	1;
	while (currNode && currNode->data != x) {
		currNode	=	currNode->next;
		currIndex++;
	}
	if (currNode) return currIndex;
	return 0;
}
int List::DeleteNode(double x) {
	Node* prevNode	=	NULL;
	Node* currNode	=	head;
	int currIndex	=	1;
	while (currNode && currNode->data != x) {
		prevNode	=	currNode;
		currNode	=	currNode->next;
		currIndex++;
	}
	if (currNode) {
		if (prevNode) {
			prevNode->next	=	currNode->next;
			delete currNode;
		}
		else {
			head		=	currNode->next;
			delete currNode;
		}
		return currIndex;
	}
	return 0;
}

void List::DisplayList()
{
   int num		=	0;
   Node* currNode	=	head;
   while (currNode != NULL)
   {
   	printf("\n%lf",currNode->data);

	currNode	=	currNode->next;
	num++;
   }
   printf("\nNumber of nodes in the list: %d",num);
}
List::~List(void) {
   Node* currNode = head, *nextNode = NULL;
   while (currNode != NULL)
   {
	nextNode	=	currNode->next;
	// destroy the current node
	delete currNode;	
	currNode	=	nextNode;
   }
}

int main(int argc, char** argv) {
	
	List list;
	list.InsertNode(0,5.4); //baarl
	list.InsertNode(1,6.5); //baarl
	list.InsertNode(-2,5.5);//baarsz
	list.InsertNode(2,10.0);//baarl
	list.DisplayList();
	list.DeleteNode(5.4);
	list.DisplayList();
	return 0;
}
